# include <Servo.h>

// Define the pin numbers for the sensors and actuators
const int LED_PIN = D4;
const int WASH_BUTTON_PIN = D8;
const int DRY_BUTTON_PIN = D6;
const int FULL_BUTTON_PIN = D7;
const int WATER_SENSOR_PIN = D2;
const int LID_SENSOR_PIN = D1;
const int DRUM_PIN = D0;
const int WATER_PUMP_PIN = D3;
const int DRUM_SLOW = 28;
const int DRUM_FAST = 29;
const int DRUM_STOP = 0;
int potVal;
Servo esc;
const int HX_OUT_PIN = D4;
const int HX_SCK_PIN = D5;
const int washdelay = 1500;
const int drydelay = 1000;
const int waterlevel = 1234000;
int waterSensorState = HIGH;

enum HX_MODE { NONE, DIFF_10Hz, TEMP_40Hz, DIFF_40Hz};
const byte HX_MODE = DIFF_40Hz;


void setup() {
  pinMode(HX_SCK_PIN, OUTPUT);
  pinMode(HX_OUT_PIN, INPUT);
  pinMode(LED_PIN, OUTPUT);
  pinMode(WASH_BUTTON_PIN, INPUT_PULLUP);
  pinMode(DRY_BUTTON_PIN, INPUT_PULLUP);
  pinMode(FULL_BUTTON_PIN, INPUT_PULLUP);
  pinMode(WATER_SENSOR_PIN, INPUT_PULLUP);
  pinMode(LID_SENSOR_PIN, INPUT_PULLUP);
  pinMode(DRUM_PIN, OUTPUT);
  pinMode(WATER_PUMP_PIN, OUTPUT);
  Serial.begin(9600);
  esc.attach(DRUM_PIN, 1000, 2000);    
  esc.write(DRUM_STOP);  
  delay(1000);
  
}

void loop() {
    // Wait for the wash button press
    Serial.println(readHX());
 if (readHX() < waterlevel) {
    waterSensorState = LOW;
  } else {
    waterSensorState = HIGH;
  }

  digitalWrite(WATER_SENSOR_PIN, waterSensorState);



if (digitalRead(WASH_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(WATER_SENSOR_PIN) == HIGH && digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the wash cycle
            esc.write(DRUM_SLOW);
            Serial.println("wash");
            digitalWrite(WATER_PUMP_PIN, HIGH);
            delay(washdelay);
            //esc.write(DRUM_STOP);
            digitalWrite(WATER_PUMP_PIN, LOW);
              delay(washdelay/3);
              digitalWrite(WATER_PUMP_PIN, HIGH);
              esc.write(DRUM_FAST);

           delay(washdelay);
            digitalWrite(WATER_PUMP_PIN, LOW);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("Not enough water or lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }

       // Wait for the dry button press
    if (digitalRead(DRY_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the dry cycle
            esc.write(DRUM_SLOW);
            Serial.println("Dry");
            delay(drydelay);

              esc.write(DRUM_FAST);

           delay(drydelay);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }

  // Wait for the full button press
    if (digitalRead(FULL_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(WATER_SENSOR_PIN) == HIGH && digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the wash cycle
            esc.write(DRUM_SLOW);
            Serial.println("washfull");
            digitalWrite(WATER_PUMP_PIN, HIGH);
            delay(washdelay);
            //esc.write(DRUM_STOP);
            digitalWrite(WATER_PUMP_PIN, LOW);
              delay(washdelay/3);
              digitalWrite(WATER_PUMP_PIN, HIGH);
              esc.write(DRUM_FAST);

           delay(washdelay);
            digitalWrite(WATER_PUMP_PIN, LOW);
            esc.write(DRUM_STOP);
           delay(washdelay/3);
            esc.write(DRUM_SLOW);
            Serial.println("Dryfull");
            delay(drydelay);

              esc.write(DRUM_FAST);

           delay(drydelay);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("Not enough water or lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }

            
    if (digitalRead(WASH_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(WATER_SENSOR_PIN) == HIGH && digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the wash cycle
            esc.write(DRUM_SLOW);
            Serial.println("wash");
            digitalWrite(WATER_PUMP_PIN, HIGH);
            delay(washdelay);
            esc.write(DRUM_STOP);
            digitalWrite(WATER_PUMP_PIN, LOW);
              delay(washdelay/3);
              digitalWrite(WATER_PUMP_PIN, HIGH);
              esc.write(DRUM_FAST);

           delay(washdelay);
            digitalWrite(WATER_PUMP_PIN, LOW);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("Not enough water or lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }

       // Wait for the dry button press
    if (digitalRead(DRY_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the dry cycle
            esc.write(DRUM_SLOW);
            Serial.println("Dry");
            delay(drydelay);
           
              esc.write(DRUM_FAST);

           delay(drydelay);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }

  // Wait for the full button press
    if (digitalRead(FULL_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(WATER_SENSOR_PIN) == HIGH && digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the wash cycle
            esc.write(DRUM_SLOW);
            Serial.println("washfull");
            digitalWrite(WATER_PUMP_PIN, HIGH);
            delay(washdelay);
            esc.write(DRUM_STOP);
            digitalWrite(WATER_PUMP_PIN, LOW);
              delay(washdelay/3);
              digitalWrite(WATER_PUMP_PIN, HIGH);
              esc.write(DRUM_FAST);

           delay(washdelay);
            digitalWrite(WATER_PUMP_PIN, LOW);
            esc.write(DRUM_STOP);
           delay(washdelay/3);
            esc.write(DRUM_SLOW);
            Serial.println("Dryfull");
            delay(drydelay);
           
              esc.write(DRUM_FAST);

           delay(drydelay);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("Not enough water or lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }
 
    }

    
unsigned long readHX() {

  // pulse clock line to start a reading
  for (char i = 0; i < HX_MODE; i++) {
    digitalWrite(HX_SCK_PIN, HIGH);
    digitalWrite(HX_SCK_PIN, LOW);
  }

  // wait for the reading to finish
  while (digitalRead(HX_OUT_PIN)) {}

  // read the 24-bit pressure as 3 bytes using SPI
  byte data[3];
  for (byte j = 3; j--;) {
    data[j] = shiftIn(HX_OUT_PIN, HX_SCK_PIN, MSBFIRST);
  }
  
  data[2] ^= 0x80;  // see note

  // shift the 3 bytes into a large integer
  long result;
  result += (long)data[2] << 16;
  result += (long)data[1] << 8;
  result += (long)data[0];

  return result;
}

